<!---
*******************************************************************************************
* COPYRIGHT NOTICE:
* Copyright 2006 Center for Technology in Government.
* The Center grants permission to use and modify this software code free of charge provided  
* this copyright notice is included. By using this code you agree to indemnify the Center from 
* any liability that might arise from its use. Selling the code is expressly forbidden.
* ******************************************************************************************

* ******************************************************************************************
* THIS INCLUDE FILE IS CALLED BY ALL THE COLDFUSION FILES IN THIS WEBSITE
* AND IT CONTROLS ALL THE WEBSERVER RETRIEVAL OF FOLDERS/FILES
* IT SUPPORTS A DIRECTORY STRUCTURE BASED ON THE MAIN NAVIGATION
* TABS OF THE WEBSITE; IT PROCESSES MUTLIPLE XML FILES WITH JUST A
* FEW XSL FILES GEARED TO LEVELS WITHIN THE WEBSITE; AND IT PASSES
* PARAMETERS FROM THE URL REQUEST QUERY STRING TO THE XSL FILES
* ******************************************************************************************
--->

<!--- 	
*******************************************************************************************
* Declares the sub parameter which may be passed in the URL Query String
* and is used to control processing of XSL sheets 						
* ******************************************************************************************
--->
<CFPARAM NAME="sub" DEFAULT="missing">

<!--- 	
*******************************************************************************************
* First, get the url string so you can manipulate it as a string 
* and direct the web server to the correct directory and file
* Parses the SCRIPT_NAME from the CGI Environment Variables to get 
* the name of the folder/file to access; stripgs the .cfm 
* extension, and replaces \ with / to build a path to the file
* that Cold Fusion will understand. Also strips the / to get 
* a file name that can be passed as a "name" parameter to the XSL
* sheet for processing													
*******************************************************************************************
--->
<cfset fullStringVar = #Replace(cgi.SCRIPT_NAME,'.cfm', '','all')#>
<cfset fullStringpathVar = #Replace(fullStringVar,'/', '\','all')#>
<cfset fullStringNameVar = #Replace(fullStringVar,'/', '','all')#>

<!---	
*******************************************************************************************
* Determines if it's the index page or not that's being referenced in the 
* user's URL and then builds the path to the appropriate XML file 
* which it stores in a ColdFusion string 									
*******************************************************************************************
--->
<cfif cgi.SCRIPT_NAME is "/index.cfm">
	<cfset concatXML = "C:\CFusionMX7\wwwroot" & fullStringpathVar & ".xml">
<cfelse>
	<cfset concatXML = "C:\CFusionMX7\wwwroot" & fullStringpathVar & fullStringpathVar & ".xml">
</cfif>
<cffile action="read" file="#concatXML#" variable="mydoc">

<!---
*******************************************************************************************
* Determines if there is a sub parameters in the user's URL or not and 
* selects the appropriate XSL file to process the XML page 				
*******************************************************************************************
--->
<cfif sub is not "missing" and sub is not "">
	<cffile action="read" file="C:\CFusionMX7\wwwroot\level2.xsl" variable="xslDoc">
<cfelse>
	<cffile action="read" file="C:\CFusionMX7\wwwroot\level1.xsl" variable="xslDoc">
</cfif>
	
<!---
*******************************************************************************************
* Puts the parameters that will be used by the XSL files into a ColdFusion 
* structure that can then be passed to the XSL files via the XmlTransform 
* function 																
*******************************************************************************************
--->
<cfscript>
xslParams = StructNew();
StructInsert(xslParams, "sub", #sub#);
StructInsert(xslParams, "name", #fullStringNameVar#);
StructInsert(xslParams, "extension", '.cfm');
</cfscript>

<!---
*******************************************************************************************
* Runs the XMLTransform function to load the XML and XSL files, pass the 
* appropriate parameters to the XSL, and produce the HTML output			
*******************************************************************************************
--->
<cfset transformedXML = XmlTransform(mydoc, xslDoc, xslParams)>
<cfoutput> #transformedXML# </cfoutput>